diff -Naur openssl-1.0.0q.orig/selftest/x509_vfy.ot openssl-1.0.0q/selftest/x509_vfy.ot
--- openssl-1.0.0q.orig/selftest/x509_vfy.ot	1970-01-01 01:00:00.000000000 +0100
+++ openssl-1.0.0q/selftest/x509_vfy.ot	2017-04-25 16:23:41.388030878 +0200
@@ -0,0 +1,453 @@
+/* -*- Mode: c++; tab-width: 4; indent-tabs-mode: t; c-basic-offset: 4 -*-
+**
+** Copyright (C) 2012-2012 Opera Software AS.  All rights reserved.
+**
+** This file is part of the Opera web browser.  It may not be distributed
+** under any circumstances.
+*/
+
+/**
+ * @file x509_vfy.ot
+ *
+ * Selftests for OpenSSL cert verification functionality.
+ *
+ * @author Alexei Khlebnikov <alexeik@opera.com>
+ *
+ */
+
+group "libopeay.x509_vfy";
+require CRYPTO_CERTIFICATE_VERIFICATION_USE_CORE_IMPLEMENTATION;
+
+language c++;
+
+include "modules/libopeay/openssl/cryptlib.h";
+
+include "modules/libopeay/addon/libopeay_util.h";
+include "modules/libopeay/openssl/pem.h";
+include "modules/libopeay/openssl/x509.h";
+include "modules/util/opfile/opfile.h";
+
+global
+{
+	/** Load the whole file into memory.
+	 *
+	 *  Caller is responsible to deallocate 'data' by OP_DELETEA,
+	 *  if and only if OpStatus::OK was returned.
+	 *
+	 *  @param       filename     Name of the file to load.
+	 *  @param[out]  data         Pointer to the data will be written here.
+	 *  @param[out]  data_length  Data length will be written here.
+	 *  @param       max_length   File length limit. The function will fail
+	 *                            if the file is bigger than this limit.
+	 */
+	OP_STATUS file2mem(
+		const char* filename,
+		char*& data,
+		OpFileLength& data_length,
+		// 640K should be enough for everyone.
+		OpFileLength max_length = 640 * 1024)
+	{
+		OpString filename16;
+		OP_STATUS status = filename16.SetFromUTF8(filename);
+		RETURN_IF_ERROR(status);
+
+		OpFile file;
+		status = file.Construct(filename16);
+		RETURN_IF_ERROR(status);
+
+		BOOL exists = FALSE;
+		status = file.Exists(exists);
+		RETURN_IF_ERROR(status);
+		if (!exists)
+			return OpStatus::ERR;
+
+		status = file.GetFileLength(data_length);
+		RETURN_IF_ERROR(status);
+		if (data_length < 0 || data_length > max_length || data_length > INT_MAX)
+			return OpStatus::ERR;
+
+		status = file.Open(OPFILE_READ);
+		RETURN_IF_ERROR(status);
+
+		if (data_length == 0)
+		{
+			data = NULL;
+			return OpStatus::OK;
+		}
+
+		data = OP_NEWA(char, static_cast<size_t>(data_length));
+		RETURN_OOM_IF_NULL(data);
+
+		OpFileLength bytes_read = 0;
+		status = file.Read(data, data_length, &bytes_read);
+		if (OpStatus::IsError(status) || !data || bytes_read != data_length)
+		{
+			OP_DELETEA(data);
+			return OpStatus::ERR;
+		}
+
+		return OpStatus::OK;
+	}
+
+	void free_bio_and_data(BIO* bio)
+	{
+		OP_ASSERT(bio);
+		int ret = BIO_reset(bio);
+		OP_ASSERT(ret == 1);
+		(void)ret;
+
+		char* data = NULL;
+		long data_length = BIO_get_mem_data(bio, &data);
+		BIO_free(bio);
+
+		if (data_length > 0)
+			OP_DELETEA(data);
+	}
+
+	BIO* file2membio(const char* filename)
+	{
+		char* data = NULL;
+		OpFileLength data_length = 0;
+
+		OP_STATUS status = file2mem(filename, data, data_length);
+		RETURN_VALUE_IF_ERROR(status, NULL);
+		OP_ASSERT(data_length < INT_MAX);
+
+		BIO* bio = BIO_new_mem_buf(data, static_cast<int>(data_length));
+		if (!bio)
+		{
+			OP_DELETEA(data);
+			ERR_clear_error();
+			return NULL;
+		}
+
+		return bio;
+	}
+
+	X509* load_X509_from_file(const char* filename)
+	{
+		BIO* bio = file2membio(filename);
+		if (!bio)
+			return NULL;
+
+		X509* x509 = PEM_read_bio_X509(bio, NULL, NULL, NULL);
+		free_bio_and_data(bio);
+		if (!x509)
+			ERR_clear_error();
+
+		return x509;
+	}
+
+	X509* load_X509_AUX_from_file(const char* filename)
+	{
+		BIO* bio = file2membio(filename);
+		if (!bio)
+			return NULL;
+
+		X509* x509 = PEM_read_bio_X509_AUX(bio, NULL, NULL, NULL);
+		free_bio_and_data(bio);
+		if (!x509)
+			ERR_clear_error();
+
+		return x509;
+	}
+
+	X509_CRL* load_X509_CRL_from_file(const char* filename)
+	{
+		BIO* bio = file2membio(filename);
+		if (!bio)
+			return NULL;
+
+		X509_CRL* crl = PEM_read_bio_X509_CRL(bio, NULL, NULL, NULL);
+		free_bio_and_data(bio);
+		if (!crl)
+			ERR_clear_error();
+
+		return crl;
+	}
+
+	X509* m_cacert = NULL;
+	X509* m_cert1  = NULL;
+	X509* m_cert2  = NULL;
+	X509_CRL* m_crl1 = NULL;
+	X509_CRL* m_crl2 = NULL;
+	STACK_OF(X509_CRL)* m_stack_of_crl1 = NULL;
+	STACK_OF(X509_CRL)* m_stack_of_crl2 = NULL;
+	X509_STORE*     m_store = NULL;
+	X509_STORE_CTX* m_store_ctx = NULL;
+
+	STACK_OF(X509)* NO_UNTRUSTED = NULL;
+	STACK_OF(X509_CRL)* NO_CRL = NULL;
+	unsigned long NO_FLAGS = 0;
+	unsigned long REQUIRE_CRL = X509_V_FLAG_CRL_CHECK_ALL | X509_V_FLAG_CRL_CHECK;
+
+} // global
+
+
+setup
+{
+	OP_ASSERT(!ERR_peek_error());
+}
+
+
+exit
+{
+	X509_STORE_CTX_free(m_store_ctx);
+	X509_STORE_free(m_store);
+	sk_X509_CRL_free(m_stack_of_crl2);
+	sk_X509_CRL_free(m_stack_of_crl1);
+	X509_CRL_free(m_crl2);
+	X509_CRL_free(m_crl1);
+	X509_free(m_cert2);
+	X509_free(m_cert1);
+	X509_free(m_cacert);
+	OP_ASSERT(!ERR_peek_error());
+}
+
+
+test("Load cacert.pem as X509_AUX")
+	file filename "TestCA/ca-data/cacert.pem";
+{
+	verify(!ERR_peek_error());
+
+	m_cacert = load_X509_AUX_from_file(filename);
+	verify(m_cacert);
+
+	verify(!ERR_peek_error());
+}
+
+
+test("Load cert1.pem  as X509")
+	file filename "TestCA/certs/cert1.pem";
+{
+	verify(!ERR_peek_error());
+
+	m_cert1 = load_X509_from_file(filename);
+	verify(m_cert1);
+
+	verify(!ERR_peek_error());
+}
+
+
+test("Load cert2.pem  as X509")
+	file filename "TestCA/certs/cert2.pem";
+{
+	verify(!ERR_peek_error());
+
+	m_cert2 = load_X509_from_file(filename);
+	verify(m_cert2);
+
+	verify(!ERR_peek_error());
+}
+
+
+test("Load crl1.pem   as X509_CRL")
+	file filename "TestCA/crls/crl1.pem";
+{
+	verify(!ERR_peek_error());
+
+	m_crl1 = load_X509_CRL_from_file(filename);
+	verify(m_crl1);
+
+	verify(!ERR_peek_error());
+}
+
+
+test("Load crl2.pem   as X509_CRL")
+	file filename "TestCA/crls/crl2.pem";
+{
+	verify(!ERR_peek_error());
+
+	m_crl2 = load_X509_CRL_from_file(filename);
+	verify(m_crl2);
+
+	verify(!ERR_peek_error());
+}
+
+
+test("Create X509_STORE")
+{
+	verify(!ERR_peek_error());
+
+	m_store = X509_STORE_new();
+	verify(m_store);
+
+	verify(!ERR_peek_error());
+}
+finally
+{
+	ERR_clear_error();
+}
+
+
+test("Add cacert.pem to X509_STORE")
+{
+	verify(!ERR_peek_error());
+
+	int ret = X509_STORE_add_cert(m_store, m_cacert);
+	verify(ret == 1);
+
+	verify(!ERR_peek_error());
+}
+finally
+{
+	ERR_clear_error();
+}
+
+
+test("Create the 1st STACK_OF(X509_CRL)")
+{
+	verify(!ERR_peek_error());
+
+	m_stack_of_crl1 = sk_X509_CRL_new_null();
+	verify(m_stack_of_crl1);
+
+	verify(!ERR_peek_error());
+}
+finally
+{
+	ERR_clear_error();
+}
+
+
+test("Add crl1.pem to m_stack_of_crl1")
+{
+	verify(!ERR_peek_error());
+	verify(m_stack_of_crl1);
+	verify(m_crl1);
+
+	int idx = sk_X509_CRL_push(m_stack_of_crl1, m_crl1);
+	verify(idx > 0);
+
+	verify(!ERR_peek_error());
+}
+finally
+{
+	ERR_clear_error();
+}
+
+
+test("Create the 2nd STACK_OF(X509_CRL) and add crl2.pem to it")
+{
+	verify(!ERR_peek_error());
+
+	verify(m_crl2);
+
+	m_stack_of_crl2 = sk_X509_CRL_new_null();
+	verify(m_stack_of_crl2);
+	verify(!ERR_peek_error());
+
+	int idx = sk_X509_CRL_push(m_stack_of_crl2, m_crl2);
+	verify(idx > 0);
+
+	verify(!ERR_peek_error());
+}
+finally
+{
+	ERR_clear_error();
+}
+
+
+test("Create X509_STORE_CTX")
+{
+	verify(!ERR_peek_error());
+
+	m_store_ctx = X509_STORE_CTX_new();
+	verify(m_store_ctx);
+
+	verify(!ERR_peek_error());
+}
+finally
+{
+	ERR_clear_error();
+}
+
+
+test("Data for cert verification is ready")
+{
+	verify(m_cacert);
+	verify(m_cert1);
+	verify(m_cert2);
+	verify(m_crl1);
+	verify(m_crl2);
+	verify(m_stack_of_crl1);
+	verify(m_stack_of_crl2);
+	verify(m_store);
+	verify(m_store_ctx);
+	verify(!ERR_peek_error());
+}
+
+
+subtest verify_cert(
+	X509*               cert,
+	STACK_OF(X509)*     untrusted_stack,
+	STACK_OF(X509_CRL)* crl_stack,
+	unsigned long       flags,
+	int                 expected_error)
+{
+	verify(!ERR_peek_error());
+	verify(m_store_ctx);
+	verify(m_store);
+
+	int ret = X509_STORE_CTX_init(m_store_ctx, m_store, cert, untrusted_stack);
+	verify(ret == 1);
+	verify(!ERR_peek_error());
+
+	X509_STORE_CTX_set0_crls(m_store_ctx, crl_stack);
+	X509_STORE_CTX_set_flags(m_store_ctx, flags);
+
+	ret = X509_verify_cert(m_store_ctx);
+	int error = X509_STORE_CTX_get_error(m_store_ctx);
+	verify((ret == 1) ^ (error != X509_V_OK));
+
+	if (error != expected_error)
+	{
+		output("vvvvvv\n");
+		output("  |X509_verify_cert() returned: %s\n", X509_V_ERR_name(error));
+		output("  |                   expected: %s\n", X509_V_ERR_name(expected_error));
+		output("  |>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>> ");
+	}
+
+	verify (error == expected_error);
+}
+finally
+{
+	if(m_store_ctx)
+		X509_STORE_CTX_cleanup(m_store_ctx);
+	ERR_clear_error();
+}
+
+table cert_verification_tests(
+	const char*         test_name,
+	X509*               cert,
+	STACK_OF(X509)*     untrusted_stack,
+	STACK_OF(X509_CRL)* crl_stack,
+	unsigned long       flags,
+	int                 expected_error)
+{
+	{ "Verify   valid cert1.pem, without CRL check",
+		m_cert1, NO_UNTRUSTED, NO_CRL, NO_FLAGS, X509_V_OK }
+	{ "Verify revoked cert2.pem, without CRL check",
+		m_cert2, NO_UNTRUSTED, NO_CRL, NO_FLAGS, X509_V_OK }
+	{ "Verify   valid cert1.pem, missing CRL",
+		m_cert1, NO_UNTRUSTED, NO_CRL, REQUIRE_CRL, X509_V_ERR_UNABLE_TO_GET_CRL }
+	{ "Verify revoked cert2.pem, missing CRL",
+		m_cert2, NO_UNTRUSTED, NO_CRL, REQUIRE_CRL, X509_V_ERR_UNABLE_TO_GET_CRL }
+	{ "Verify   valid cert1.pem, with crl1.pem",
+		m_cert1, NO_UNTRUSTED, m_stack_of_crl1, REQUIRE_CRL, X509_V_OK }
+	{ "Verify revoked cert2.pem, with crl1.pem",
+		m_cert2, NO_UNTRUSTED, m_stack_of_crl1, REQUIRE_CRL, X509_V_OK }
+	{ "Verify   valid cert1.pem, with crl2.pem",
+		m_cert1, NO_UNTRUSTED, m_stack_of_crl2, REQUIRE_CRL, X509_V_OK }
+	{ "Verify revoked cert2.pem, with crl2.pem",
+		m_cert2, NO_UNTRUSTED, m_stack_of_crl2, REQUIRE_CRL, X509_V_ERR_CERT_REVOKED }
+}
+
+foreach (test_name, cert, untrusted_stack, crl_stack, flags, expected_error) from cert_verification_tests
+{
+	test(test_name)
+		require success("Data for cert verification is ready");
+	{
+		verify_cert(cert, untrusted_stack, crl_stack, flags, expected_error);
+	}
+}
diff -Naur openssl-1.0.0q.orig/ssl/.gitignore openssl-1.0.0q/ssl/.gitignore
--- openssl-1.0.0q.orig/ssl/.gitignore	1970-01-01 01:00:00.000000000 +0100
+++ openssl-1.0.0q/ssl/.gitignore	2017-04-25 16:23:41.389032122 +0200
@@ -0,0 +1,2 @@
+/.depend
+/*.d
diff -Naur openssl-1.0.0q.orig/ssl/d1_both.c openssl-1.0.0q/ssl/d1_both.c
--- openssl-1.0.0q.orig/ssl/d1_both.c	2015-01-15 15:54:59.000000000 +0100
+++ openssl-1.0.0q/ssl/d1_both.c	2017-04-25 16:23:41.398030752 +0200
@@ -113,6 +113,8 @@
  * [including the GNU Public Licence.]
  */
 
+#error("/* ARRAY FILE UNUSED. CHECK ARRAYS BEFORE USING */")
+
 #include <limits.h>
 #include <string.h>
 #include <stdio.h>
diff -Naur openssl-1.0.0q.orig/ssl/d1_clnt.c openssl-1.0.0q/ssl/d1_clnt.c
--- openssl-1.0.0q.orig/ssl/d1_clnt.c	2015-01-15 15:54:59.000000000 +0100
+++ openssl-1.0.0q/ssl/d1_clnt.c	2017-04-25 16:23:41.400030448 +0200
@@ -113,6 +113,8 @@
  * [including the GNU Public Licence.]
  */
 
+#error("/* ARRAY FILE UNUSED. CHECK ARRAYS BEFORE USING */")
+
 #include <stdio.h>
 #include "ssl_locl.h"
 #ifndef OPENSSL_NO_KRB5
diff -Naur openssl-1.0.0q.orig/ssl/d1_pkt.c openssl-1.0.0q/ssl/d1_pkt.c
--- openssl-1.0.0q.orig/ssl/d1_pkt.c	2015-01-15 15:54:59.000000000 +0100
+++ openssl-1.0.0q/ssl/d1_pkt.c	2017-04-25 16:23:41.401030854 +0200
@@ -113,6 +113,8 @@
  * [including the GNU Public Licence.]
  */
 
+#error("/* ARRAY FILE UNUSED. CHECK ARRAYS BEFORE USING */")
+
 #include <stdio.h>
 #include <errno.h>
 #define USE_SOCKETS
diff -Naur openssl-1.0.0q.orig/ssl/d1_srvr.c openssl-1.0.0q/ssl/d1_srvr.c
--- openssl-1.0.0q.orig/ssl/d1_srvr.c	2015-01-15 15:54:59.000000000 +0100
+++ openssl-1.0.0q/ssl/d1_srvr.c	2017-04-25 16:23:41.402030423 +0200
@@ -113,6 +113,8 @@
  * [including the GNU Public Licence.]
  */
 
+#error("/* ARRAY FILE UNUSED. CHECK ARRAYS BEFORE USING */")
+
 #include <stdio.h>
 #include "ssl_locl.h"
 #include <openssl/buffer.h>
diff -Naur openssl-1.0.0q.orig/ssl/install.com openssl-1.0.0q/ssl/install.com
--- openssl-1.0.0q.orig/ssl/install.com	1970-01-01 01:00:00.000000000 +0100
+++ openssl-1.0.0q/ssl/install.com	2017-04-25 16:23:41.403029991 +0200
@@ -0,0 +1,90 @@
+$! INSTALL.COM -- Installs the files in a given directory tree
+$!
+$! Author: Richard Levitte <richard@levitte.org>
+$! Time of creation: 22-MAY-1998 10:13
+$!
+$! P1	root of the directory tree
+$!
+$	IF P1 .EQS. ""
+$	THEN
+$	    WRITE SYS$OUTPUT "First argument missing."
+$	    WRITE SYS$OUTPUT -
+		  "It should be the directory where you want things installed."
+$	    EXIT
+$	ENDIF
+$
+$	IF (F$GETSYI("CPU").LT.128)
+$	THEN
+$	    ARCH := VAX
+$	ELSE
+$	    ARCH = F$EDIT( F$GETSYI( "ARCH_NAME"), "UPCASE")
+$	    IF (ARCH .EQS. "") THEN ARCH = "UNK"
+$	ENDIF
+$
+$	ROOT = F$PARSE(P1,"[]A.;0",,,"SYNTAX_ONLY,NO_CONCEAL") - "A.;0"
+$	ROOT_DEV = F$PARSE(ROOT,,,"DEVICE","SYNTAX_ONLY")
+$	ROOT_DIR = F$PARSE(ROOT,,,"DIRECTORY","SYNTAX_ONLY") -
+		   - "[000000." - "][" - "[" - "]"
+$	ROOT = ROOT_DEV + "[" + ROOT_DIR
+$
+$	DEFINE/NOLOG WRK_SSLROOT 'ROOT'.] /TRANS=CONC
+$	DEFINE/NOLOG WRK_SSLXLIB WRK_SSLROOT:['ARCH'_LIB]
+$	DEFINE/NOLOG WRK_SSLINCLUDE WRK_SSLROOT:[INCLUDE]
+$	DEFINE/NOLOG WRK_SSLXEXE WRK_SSLROOT:['ARCH'_EXE]
+$
+$	IF F$PARSE("WRK_SSLROOT:[000000]") .EQS. "" THEN -
+	   CREATE/DIR/LOG WRK_SSLROOT:[000000]
+$	IF F$PARSE("WRK_SSLXLIB:") .EQS. "" THEN -
+	   CREATE/DIR/LOG WRK_SSLXLIB:
+$	IF F$PARSE("WRK_SSLINCLUDE:") .EQS. "" THEN -
+	   CREATE/DIR/LOG WRK_SSLINCLUDE:
+$	IF F$PARSE("WRK_SSLXEXE:") .EQS. "" THEN -
+	   CREATE/DIR/LOG WRK_SSLXEXE:
+$
+$	EXHEADER := ssl.h,ssl2.h,ssl3.h,ssl23.h,tls1.h,dtls1.h,kssl.h
+$	E_EXE := ssl_task
+$	LIBS := LIBSSL,LIBSSL32
+$
+$	XEXE_DIR := [-.'ARCH'.EXE.SSL]
+$
+$	COPY 'EXHEADER' WRK_SSLINCLUDE:/LOG
+$	SET FILE/PROT=WORLD:RE WRK_SSLINCLUDE:'EXHEADER'
+$
+$	I = 0
+$ LOOP_EXE: 
+$	E = F$EDIT(F$ELEMENT(I, ",", E_EXE),"TRIM")
+$	I = I + 1
+$	IF E .EQS. "," THEN GOTO LOOP_EXE_END
+$	SET NOON
+$	IF F$SEARCH(XEXE_DIR+E+".EXE") .NES. ""
+$	THEN
+$	  COPY 'XEXE_DIR''E'.EXE WRK_SSLXEXE:'E'.EXE/log
+$	  SET FILE/PROT=W:RE WRK_SSLXEXE:'E'.EXE
+$	ENDIF
+$	SET ON
+$	GOTO LOOP_EXE
+$ LOOP_EXE_END:
+$
+$	I = 0
+$ LOOP_LIB: 
+$	E = F$EDIT(F$ELEMENT(I, ",", LIBS),"TRIM")
+$	I = I + 1
+$	IF E .EQS. "," THEN GOTO LOOP_LIB_END
+$	SET NOON
+$! Object library.
+$	IF F$SEARCH(XEXE_DIR+E+".OLB") .NES. ""
+$	THEN
+$	  COPY 'XEXE_DIR''E'.OLB WRK_SSLXLIB:'E'.OLB/log
+$	  SET FILE/PROT=W:RE WRK_SSLXLIB:'E'.OLB
+$	ENDIF
+$! Shareable image.
+$	IF F$SEARCH(XEXE_DIR+E+".EXE") .NES. ""
+$	THEN
+$	  COPY 'XEXE_DIR''E'.EXE WRK_SSLXLIB:'E'.EXE/log
+$	  SET FILE/PROT=W:RE WRK_SSLXLIB:'E'.EXE
+$	ENDIF
+$	SET ON
+$	GOTO LOOP_LIB
+$ LOOP_LIB_END:
+$
+$	EXIT
diff -Naur openssl-1.0.0q.orig/ssl/kssl.c openssl-1.0.0q/ssl/kssl.c
--- openssl-1.0.0q.orig/ssl/kssl.c	2015-01-15 15:54:59.000000000 +0100
+++ openssl-1.0.0q/ssl/kssl.c	2017-04-25 16:23:41.404030118 +0200
@@ -66,6 +66,8 @@
 **          		Real RFC2712 KerberosWrapper replaces AP_REQ.
 */
 
+#error("/* ARRAY FILE UNUSED. CHECK ARRAYS BEFORE USING */")
+
 #include <openssl/opensslconf.h>
 
 #include <string.h>
diff -Naur openssl-1.0.0q.orig/ssl/s23_clnt.c openssl-1.0.0q/ssl/s23_clnt.c
--- openssl-1.0.0q.orig/ssl/s23_clnt.c	2015-01-15 15:54:59.000000000 +0100
+++ openssl-1.0.0q/ssl/s23_clnt.c	2017-04-25 16:23:41.412031414 +0200
@@ -109,6 +109,8 @@
  *
  */
 
+#error("/* ARRAY FILE UNUSED. CHECK ARRAYS BEFORE USING */")
+
 #include <stdio.h>
 #include "ssl_locl.h"
 #include <openssl/buffer.h>
diff -Naur openssl-1.0.0q.orig/ssl/s23_srvr.c openssl-1.0.0q/ssl/s23_srvr.c
--- openssl-1.0.0q.orig/ssl/s23_srvr.c	2015-01-15 15:54:59.000000000 +0100
+++ openssl-1.0.0q/ssl/s23_srvr.c	2017-04-25 16:23:41.413031262 +0200
@@ -109,6 +109,8 @@
  *
  */
 
+#error("/* ARRAY FILE UNUSED. CHECK ARRAYS BEFORE USING */")
+
 #include <stdio.h>
 #include "ssl_locl.h"
 #include <openssl/buffer.h>
diff -Naur openssl-1.0.0q.orig/ssl/s2_clnt.c openssl-1.0.0q/ssl/s2_clnt.c
--- openssl-1.0.0q.orig/ssl/s2_clnt.c	2015-01-15 15:43:49.000000000 +0100
+++ openssl-1.0.0q/ssl/s2_clnt.c	2017-04-25 16:23:41.414031110 +0200
@@ -422,7 +422,6 @@
 		memset(s->session->session_id,0,
 			SSL_MAX_SSL_SESSION_ID_LENGTH_IN_BYTES);
 		s->session->session_id_length=0;
-		*/
 #endif
 
 		/* we need to do this in case we were trying to reuse a 
diff -Naur openssl-1.0.0q.orig/ssl/s2_lib.c openssl-1.0.0q/ssl/s2_lib.c
--- openssl-1.0.0q.orig/ssl/s2_lib.c	2015-01-15 15:43:49.000000000 +0100
+++ openssl-1.0.0q/ssl/s2_lib.c	2017-04-25 16:23:41.415030957 +0200
@@ -109,6 +109,8 @@
  *
  */
 
+#error("/* ARRAY FILE UNUSED. CHECK ARRAYS BEFORE USING */")
+
 #include "ssl_locl.h"
 #ifndef OPENSSL_NO_SSL2
 #include <stdio.h>
diff -Naur openssl-1.0.0q.orig/ssl/s2_pkt.c openssl-1.0.0q/ssl/s2_pkt.c
--- openssl-1.0.0q.orig/ssl/s2_pkt.c	2015-01-15 15:43:49.000000000 +0100
+++ openssl-1.0.0q/ssl/s2_pkt.c	2017-04-25 16:23:41.416030805 +0200
@@ -109,6 +109,8 @@
  *
  */
 
+#error("/* ARRAY FILE UNUSED. CHECK ARRAYS BEFORE USING */")
+
 #include "ssl_locl.h"
 #ifndef OPENSSL_NO_SSL2
 #include <stdio.h>
diff -Naur openssl-1.0.0q.orig/ssl/s3_both.c openssl-1.0.0q/ssl/s3_both.c
--- openssl-1.0.0q.orig/ssl/s3_both.c	2015-01-15 15:54:59.000000000 +0100
+++ openssl-1.0.0q/ssl/s3_both.c	2017-04-25 16:23:41.417031491 +0200
@@ -114,9 +114,13 @@
  * SUN MICROSYSTEMS, INC., and contributed to the OpenSSL project.
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <limits.h>
 #include <string.h>
 #include <stdio.h>
+#endif /* !OPERA_SMALL_VERSION */
+
+#include <openssl/cryptlib.h>
 #include "ssl_locl.h"
 #include <openssl/buffer.h>
 #include <openssl/rand.h>
@@ -162,7 +166,7 @@
 		i=s->method->ssl3_enc->final_finish_mac(s,
 			sender,slen,s->s3->tmp.finish_md);
 		s->s3->tmp.finish_md_len = i;
-		memcpy(p, s->s3->tmp.finish_md, i);
+		op_memcpy(p, s->s3->tmp.finish_md, i);
 		p+=i;
 		l=i;
 
@@ -240,7 +244,7 @@
 		goto f_err;
 		}
 
-	if (CRYPTO_memcmp(p, s->s3->tmp.peer_finish_md, i) != 0)
+	if (op_memcmp(p, s->s3->tmp.peer_finish_md, i) != 0)
 		{
 		al=SSL_AD_DECRYPT_ERROR;
 		SSLerr(SSL_F_SSL3_GET_FINISHED,SSL_R_DIGEST_CHECK_FAILED);
@@ -501,7 +505,7 @@
 		}
 
 	/* next state (stn) */
-	p = s->init_msg;
+	p = (unsigned char*) s->init_msg;
 	n = s->s3->tmp.message_size - s->init_num;
 	while (n > 0)
 		{
@@ -684,7 +688,7 @@
 	    sz >= sizeof(*ent))
 		{
 		list->chunklen = sz;
-		ent = mem;
+		ent = (SSL3_BUF_FREELIST_ENTRY *)mem;
 		ent->next = list->head;
 		list->head = ent;
 		++list->len;
@@ -728,7 +732,7 @@
 		if (!(s->options & SSL_OP_NO_COMPRESSION))
 			len += SSL3_RT_MAX_COMPRESSED_OVERHEAD;
 #endif
-		if ((p=freelist_extract(s->ctx, 1, len)) == NULL)
+		if ((p=(unsigned char *)freelist_extract(s->ctx, 1, len)) == NULL)
 			goto err;
 		s->s3->rbuf.buf = p;
 		s->s3->rbuf.len = len;
@@ -769,7 +773,7 @@
 			len += headerlen + align
 				+ SSL3_RT_SEND_MAX_ENCRYPTED_OVERHEAD;
 
-		if ((p=freelist_extract(s->ctx, 0, len)) == NULL)
+		if ((p=(unsigned char *)freelist_extract(s->ctx, 0, len)) == NULL)
 			goto err;
 		s->s3->wbuf.buf = p;
 		s->s3->wbuf.len = len;
diff -Naur openssl-1.0.0q.orig/ssl/s3_clnt.c openssl-1.0.0q/ssl/s3_clnt.c
--- openssl-1.0.0q.orig/ssl/s3_clnt.c	2015-01-15 15:54:59.000000000 +0100
+++ openssl-1.0.0q/ssl/s3_clnt.c	2017-04-25 16:23:41.419030907 +0200
@@ -148,7 +148,11 @@
  * OTHERWISE.
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
+#endif /* !OPERA_SMALL_VERSION */
+
+#include <openssl/cryptlib.h>
 #include "ssl_locl.h"
 #include "kssl_lcl.h"
 #include <openssl/buffer.h>
@@ -651,7 +655,7 @@
 		s->client_version=s->version;
 
 		/* Random stuff */
-		memcpy(p,s->s3->client_random,SSL3_RANDOM_SIZE);
+		op_memcpy(p,s->s3->client_random,SSL3_RANDOM_SIZE);
 		p+=SSL3_RANDOM_SIZE;
 
 		/* Session ID */
@@ -667,7 +671,7 @@
 				SSLerr(SSL_F_SSL3_CLIENT_HELLO, ERR_R_INTERNAL_ERROR);
 				goto err;
 				}
-			memcpy(p,s->session->session_id,i);
+			op_memcpy(p,s->session->session_id,i);
 			p+=i;
 			}
 		
@@ -790,7 +794,7 @@
 
 	/* load the server hello data */
 	/* load the server random */
-	memcpy(s->s3->server_random,p,SSL3_RANDOM_SIZE);
+	op_memcpy(s->s3->server_random,p,SSL3_RANDOM_SIZE);
 	p+=SSL3_RANDOM_SIZE;
 
 	/* get the session-id */
@@ -822,10 +826,10 @@
 #endif /* OPENSSL_NO_TLSEXT */
 
 	if (j != 0 && j == s->session->session_id_length
-	    && memcmp(p,s->session->session_id,j) == 0)
+	    && op_memcmp(p,s->session->session_id,j) == 0)
 	    {
 	    if(s->sid_ctx_length != s->session->sid_ctx_length
-	       || memcmp(s->session->sid_ctx,s->sid_ctx,s->sid_ctx_length))
+	       || op_memcmp(s->session->sid_ctx,s->sid_ctx,s->sid_ctx_length))
 		{
 		/* actually a client application bug */
 		al=SSL_AD_ILLEGAL_PARAMETER;
@@ -849,7 +853,7 @@
 				}
 			}
 		s->session->session_id_length=j;
-		memcpy(s->session->session_id,p,j); /* j could be 0 */
+		op_memcpy(s->session->session_id,p,j); /* j could be 0 */
 		}
 	p+=j;
 	c=ssl_get_cipher_by_char(s,p);
@@ -1959,13 +1963,13 @@
 		OPENSSL_free(s->session->tlsext_tick);
 		s->session->tlsext_ticklen = 0;
 		}
-	s->session->tlsext_tick = OPENSSL_malloc(ticklen);
+	s->session->tlsext_tick = (unsigned char*)OPENSSL_malloc(ticklen);
 	if (!s->session->tlsext_tick)
 		{
 		SSLerr(SSL_F_SSL3_GET_NEW_SESSION_TICKET,ERR_R_MALLOC_FAILURE);
 		goto err;
 		}
-	memcpy(s->session->tlsext_tick, p, ticklen);
+	op_memcpy(s->session->tlsext_tick, p, ticklen);
 	s->session->tlsext_ticklen = ticklen;
 	/* There are two ways to detect a resumed ticket sesion.
 	 * One is to set an appropriate session ID and then the server
@@ -2034,7 +2038,7 @@
 		}
 	if (s->tlsext_ocsp_resp)
 		OPENSSL_free(s->tlsext_ocsp_resp);
-	s->tlsext_ocsp_resp = BUF_memdup(p, resplen);
+	s->tlsext_ocsp_resp = (unsigned char*)BUF_memdup(p, resplen);
 	if (!s->tlsext_ocsp_resp)
 		{
 		al = SSL_AD_INTERNAL_ERROR;
@@ -2125,7 +2129,7 @@
 		else if (alg_k & SSL_kRSA)
 			{
 			RSA *rsa;
-			unsigned char tmp_buf[SSL_MAX_MASTER_KEY_LENGTH];
+			unsigned char tmp_buf[SSL_MAX_MASTER_KEY_LENGTH]; /* ARRAY OK 2009-09-08 alexeik */
 
 			if (s->session->sess_cert == NULL)
 				{
@@ -2188,6 +2192,7 @@
 			}
 #endif
 #ifndef OPENSSL_NO_KRB5
+#error("/* ARRAY FILE PART UNUSED. RECHECK ARRAYS BEFORE USING */")
 		else if (alg_k & SSL_kKRB5)
 			{
 			krb5_error_code	krb5rc;
@@ -2197,10 +2202,10 @@
 			krb5_data	authenticator, *authp = NULL;
 			EVP_CIPHER_CTX	ciph_ctx;
 			const EVP_CIPHER *enc = NULL;
-			unsigned char	iv[EVP_MAX_IV_LENGTH];
-			unsigned char	tmp_buf[SSL_MAX_MASTER_KEY_LENGTH];
+			unsigned char	iv[EVP_MAX_IV_LENGTH];              /* ARRAY OK UNUSED 2009-09-08 alexeik */
+			unsigned char	tmp_buf[SSL_MAX_MASTER_KEY_LENGTH]; /* ARRAY OK UNUSED 2009-09-08 alexeik */
 			unsigned char	epms[SSL_MAX_MASTER_KEY_LENGTH 
-						+ EVP_MAX_IV_LENGTH];
+						+ EVP_MAX_IV_LENGTH]; /* ARRAY OK UNUSED 2009-09-08 alexeik */
 			int 		padl, outl = sizeof(epms);
 
 			EVP_CIPHER_CTX_init(&ciph_ctx);
@@ -2258,7 +2263,7 @@
 
 			/*  KerberosWrapper.Ticket		*/
 			s2n(enc_ticket->length,p);
-			memcpy(p, enc_ticket->data, enc_ticket->length);
+			op_memcpy(p, enc_ticket->data, enc_ticket->length);
 			p+= enc_ticket->length;
 			n = enc_ticket->length + 2;
 
@@ -2266,7 +2271,7 @@
 			if (authp  &&  authp->length)  
 				{
 				s2n(authp->length,p);
-				memcpy(p, authp->data, authp->length);
+				op_memcpy(p, authp->data, authp->length);
 				p+= authp->length;
 				n+= authp->length + 2;
 				
@@ -2308,7 +2313,7 @@
 
 			/*  KerberosWrapper.EncryptedPreMasterSecret	*/
 			s2n(outl,p);
-			memcpy(p, epms, outl);
+			op_memcpy(p, epms, outl);
 			p+=outl;
 			n+=outl + 2;
 
@@ -2566,7 +2571,7 @@
 				/* Encoded point will be copied here */
 				p += 1; 
 				/* copy the point */
-				memcpy((unsigned char *)p, encodedPoint, n);
+				op_memcpy((unsigned char *)p, encodedPoint, n);
 				/* increment n to account for length field */
 				n += 1; 
 				}
@@ -2796,7 +2801,7 @@
 int ssl3_send_client_verify(SSL *s)
 	{
 	unsigned char *p,*d;
-	unsigned char data[MD5_DIGEST_LENGTH+SHA_DIGEST_LENGTH];
+	unsigned char data[MD5_DIGEST_LENGTH+SHA_DIGEST_LENGTH]; /* ARRAY OK 2009-09-08 alexeik */
 	EVP_PKEY *pkey;
 	EVP_PKEY_CTX *pctx=NULL;
 #ifndef OPENSSL_NO_RSA
diff -Naur openssl-1.0.0q.orig/ssl/s3_enc.c openssl-1.0.0q/ssl/s3_enc.c
--- openssl-1.0.0q.orig/ssl/s3_enc.c	2015-01-15 15:54:59.000000000 +0100
+++ openssl-1.0.0q/ssl/s3_enc.c	2017-04-25 16:23:41.420031314 +0200
@@ -135,7 +135,11 @@
  * OTHERWISE.
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
+#endif /* !OPERA_SMALL_VERSION */
+
+#include <openssl/cryptlib.h>
 #include "ssl_locl.h"
 #include <openssl/evp.h>
 #include <openssl/md5.h>
@@ -199,7 +203,7 @@
 		if ((int)(i+MD5_DIGEST_LENGTH) > num)
 			{
 			EVP_DigestFinal_ex(&m5,smd,NULL);
-			memcpy(km,smd,(num-i));
+			op_memcpy(km,smd,(num-i));
 			}
 		else
 			EVP_DigestFinal_ex(&m5,km,NULL);
@@ -215,8 +219,8 @@
 int ssl3_change_cipher_state(SSL *s, int which)
 	{
 	unsigned char *p,*mac_secret;
-	unsigned char exp_key[EVP_MAX_KEY_LENGTH];
-	unsigned char exp_iv[EVP_MAX_IV_LENGTH];
+	unsigned char exp_key[EVP_MAX_KEY_LENGTH]; /* ARRAY OK 2009-09-08 alexeik */
+	unsigned char exp_iv[EVP_MAX_IV_LENGTH];   /* ARRAY OK 2009-09-08 alexeik */
 	unsigned char *ms,*key,*iv,*er1,*er2;
 	EVP_CIPHER_CTX *dd;
 	const EVP_CIPHER *c;
@@ -244,7 +248,7 @@
 		{
 		if (s->enc_read_ctx != NULL)
 			reuse_dd = 1;
-		else if ((s->enc_read_ctx=OPENSSL_malloc(sizeof(EVP_CIPHER_CTX))) == NULL)
+		else if ((s->enc_read_ctx=(EVP_CIPHER_CTX*)OPENSSL_malloc(sizeof(EVP_CIPHER_CTX))) == NULL)
 			goto err;
 		else
 			/* make sure it's intialized in case we exit later with an error */
@@ -274,14 +278,14 @@
 				goto err;
 			}
 #endif
-		memset(&(s->s3->read_sequence[0]),0,8);
+		op_memset(&(s->s3->read_sequence[0]),0,8);
 		mac_secret= &(s->s3->read_mac_secret[0]);
 		}
 	else
 		{
 		if (s->enc_write_ctx != NULL)
 			reuse_dd = 1;
-		else if ((s->enc_write_ctx=OPENSSL_malloc(sizeof(EVP_CIPHER_CTX))) == NULL)
+		else if ((s->enc_write_ctx=(EVP_CIPHER_CTX*)OPENSSL_malloc(sizeof(EVP_CIPHER_CTX))) == NULL)
 			goto err;
 		else
 			/* make sure it's intialized in case we exit later with an error */
@@ -305,7 +309,7 @@
 				}
 			}
 #endif
-		memset(&(s->s3->write_sequence[0]),0,8);
+		op_memset(&(s->s3->write_sequence[0]),0,8);
 		mac_secret= &(s->s3->write_mac_secret[0]);
 		}
 
@@ -347,7 +351,7 @@
 		}
 
 	EVP_MD_CTX_init(&md);
-	memcpy(mac_secret,ms,i);
+	op_memcpy(mac_secret,ms,i);
 	if (is_exp)
 		{
 		/* In here I set both the read and write key/iv to the
@@ -419,7 +423,7 @@
 
 	ssl3_cleanup_key_block(s);
 
-	if ((p=OPENSSL_malloc(num)) == NULL)
+	if ((p=(unsigned char*)OPENSSL_malloc(num)) == NULL)
 		goto err;
 
 	s->s3->tmp.key_block_length=num;
@@ -504,7 +508,7 @@
 	if ((s->session == NULL) || (ds == NULL) ||
 		(enc == NULL))
 		{
-		memmove(rec->data,rec->input,rec->length);
+		op_memmove(rec->data,rec->input,rec->length);
 		rec->input=rec->data;
 		}
 	else
@@ -595,7 +599,7 @@
 
 	/* Allocate handshake_dgst array */
 	ssl3_free_digest_list(s);
-	s->s3->handshake_dgst = OPENSSL_malloc(SSL_MAX_DIGEST * sizeof(EVP_MD_CTX *));
+	s->s3->handshake_dgst = (EVP_MD_CTX**)OPENSSL_malloc(SSL_MAX_DIGEST * sizeof(EVP_MD_CTX *));
 	memset(s->s3->handshake_dgst,0,SSL_MAX_DIGEST *sizeof(EVP_MD_CTX *));
 	hdatalen = BIO_get_mem_data(s->s3->handshake_buffer,&hdata);
 	if (hdatalen <= 0)
@@ -652,7 +656,7 @@
 	unsigned int ret;
 	int npad,n;
 	unsigned int i;
-	unsigned char md_buf[EVP_MAX_MD_SIZE];
+	unsigned char md_buf[EVP_MAX_MD_SIZE]; /* ARRAY OK 2009-09-08 alexeik */
 	EVP_MD_CTX ctx,*d=NULL;
 
 	if (s->s3->handshake_buffer) 
@@ -816,7 +820,7 @@
 int ssl3_generate_master_secret(SSL *s, unsigned char *out, unsigned char *p,
 	     int len)
 	{
-	static const unsigned char *salt[3]={
+	static const unsigned char *salt[3]={  /* ARRAY OK 2009-09-08 alexeik */
 #ifndef CHARSET_EBCDIC
 		(const unsigned char *)"A",
 		(const unsigned char *)"BB",
@@ -827,7 +831,7 @@
 		(const unsigned char *)"\x43\x43\x43",
 #endif
 		};
-	unsigned char buf[EVP_MAX_MD_SIZE];
+	unsigned char buf[EVP_MAX_MD_SIZE]; /* ARRAY OK 2009-09-08 alexeik */
 	EVP_MD_CTX ctx;
 	int i,ret=0;
 	unsigned int n;
@@ -836,7 +840,7 @@
 	for (i=0; i<3; i++)
 		{
 		EVP_DigestInit_ex(&ctx,s->ctx->sha1, NULL);
-		EVP_DigestUpdate(&ctx,salt[i],strlen((const char *)salt[i]));
+		EVP_DigestUpdate(&ctx,salt[i],op_strlen((const char *)salt[i]));
 		EVP_DigestUpdate(&ctx,p,len);
 		EVP_DigestUpdate(&ctx,&(s->s3->client_random[0]),
 			SSL3_RANDOM_SIZE);
